$Id: README 62528 2022-03-08 22:40:22Z karl $
Public domain.  Originally written 2005 by Karl Berry.

Extra utilities we (optionally) compile for TeX Live.
See comments in ../texk/README.

asymptote 2.79 - checked 8mar22
  update to TL from CTAN, to include prebuilt doc.
  see https://tug.org/texlive/build.html#asymptote
  and tlpkg/bin/tl-update-asy

autosp 2021-01-07 - checked 08jan21
  https://ctan.org/pkg/autosp

axodraw2 2.1.1c - checked 5mar21
  https://ctan.org/pkg/axodraw2
  (also has files in Master; ctan2tl will install)

devnag - from devanagari package installed in texmf-dist.

lacheck - maintained here, by us

m-tx 0.63a - checked 29apr18
  https://ctan.org/pkg/m-tx/

pmx 2.9.8a - checked 08mar22
  https://ctan.org/pkg/pmx/

ps2eps 1.70 - checked 03jul21
  http://tm.uka.de/~bless/ps2eps

t1utils 1.42 - checked 31oct20
  http://www.lcdf.org/type/

texdoctk - reluctantly maintained here in TL
  If anyone would like to resume development, just let us know.

tpic2pdftex 1.97 - checked 10may12
  https://ctan.org/pkg/tpic2pdftex/

vlna 1.5 - checked 10may12
  ftp://math.feld.cvut.cz/pub/olsak/vlna/

xindy - see just below

xml2pmx 2021-02-07 - checked 25sep21
  https://ctan.org/pkg/xml2pmx/

xpdfopen 0.86 - checked 9jul18
  https://ctan.org/pkg/xpdfopen/
  http://cs.acadiau.ca/~jdiamond/xpdfopen/


xindy 2.5.1 - checked 15sep14
  http://www.ctan.org/pkg/xindy

After building clisp as described below, run the TL
  Build --enable-xindy CLISP=$clisp_builddir/clisp
to include xindy in the build.  It is disabled by default.

xindy/xindy-src/README-clisp has alternative instructions with some
extra information, especially for those building xindy on its own. The
process here is written for building clisp-for-xindy-for-TL. The
differences are minimal.

mkdir clisp; cd clisp
clisp_basedir=`pwd`
clisp_toolsdir=$clisp_basedir/clisp-tools
clisp_builddir=$clisp_basedir/clisp-build
mkdir $clisp_toolsdir

wget=wget  # or "curl -O" or whatever

libsigsegv_ver=libsigsegv-2.13
cd $clisp_basedir
$wget http://ftp.gnu.org/gnu/libsigsegv/$libsigsegv_ver.tar.gz
gzip -dc $libsigsegv_ver.tar.gz | tar xf -
cd $libsigsegv_ver
./configure -C --prefix=$clisp_toolsdir --disable-shared --enable-static \
&& make && make check && make install
#
# you may need this hack on 64-bit systems
# if clisp's configure does not find libsigsegv.  Harmless to do in any case.
ln -s lib $clisp_toolsdir/lib64 # for GNU/Linux 64-bit
ln -s . $clisp_toolsdir/lib/64  # for Solaris 64-bit
#
# if you can't build libsigsegv, pass --ignore-absence-of-libsigsegv
# when running configure for clisp.

# may be able to omit iconv if have new enough in libc or elsewhere.
# (and omit --with-libiconv-prefix below)
libiconv_ver=libiconv-1.16
cd $clisp_basedir
$wget http://ftp.gnu.org/gnu/libiconv/$libiconv_ver.tar.gz
gzip -dc $libiconv_ver.tar.gz | tar xf -
cd $libiconv_ver
./configure -C --prefix=$clisp_toolsdir \
  --disable-shared --enable-static --disable-nls \
&& make && make check && make install

# would probably be ideal to also do a local libtermcap or ncurses,
# but doesn't seem to be a problem in practice?

# foil wrong attempts at dynamic linking, etc. Don't worry if any don't exist.
(cd $clisp_basedir/clisp-tools/lib && mkdir .dy && mv *.dylib *.la .dy)

clisp_ver=clisp-2.49.92
cd $clisp_basedir
$wget https://alpha.gnu.org/gnu/clisp/$clisp_ver.tar.bz2
bunzip2 -dc $clisp_ver.tar.bz2 | tar xf -
cd $clisp_ver

# On Cygwin:
# mv modules/syscalls/configure modules/syscalls/configure.orig
# sed -e '{s%-luuid%-L/usr/lib/w32api -luuid%}' \
#  modules/syscalls/configure.orig > modules/syscalls/configure
# On FreeBSD/amd64: add --disable-mmap.
#
# Do not link with ncurses, we don't need it and versions differ.
# but, this doesn't work with 2.49.92, results in undefined references
# to the termcap functions.
#ac_cv_search_tgetent=" "; export ac_cv_search_tgetent
#
./configure CPPFLAGS=-DUNIX_BINARY_DISTRIB --prefix=$clisp_toolsdir \
  --without-readline --without-dynamic-modules \
  --disable-nls \
  --with-libsigsegv-prefix=$clisp_toolsdir \
  --with-libiconv-prefix=$clisp_toolsdir \
  $clisp_builddir \
&& (cd $clisp_builddir && make)

Then the files we want are $clisp_builddir/lisp.run and lispinit.mem,
to be installed as <tlbindir>/xindy.{run,mem}.

There may be clisp test failures relating to sockets on some
systems. Since xindy doesn't use sockets, we can ignore those for TL.
